#!/bin/sh

b=$1

# file risolto da FF
if grep "found legal plan" ff &>/dev/null
    then

    rm -f $b.soln  &> /dev/null
    touch $b.soln
    
    count=0
    while read -r line; do
	a=`echo $line | grep "[0-9][0-9]*:" | cut -d ":" -f2 | tr "[a-z]" "[A-Z]"`
	if [[ ! -z $a ]]; then
	    length=${#a}
	    echo "$count: (${a: 1: $length}) [1]" >> $b.soln
	    let count+=1
	fi
    done < ff

    echo "Problem solved by FF!"
    exit 0
fi

# file risolto da downward
if grep "Solution found" downward &>/dev/null
    then

    count=0
    soluzione=0

    rm -f $b.soln  &> /dev/null
    touch $b.soln

    while read -r line; do
        echo "$count: $line [1]" | tr "[a-z]" "[A-Z]" >> $b.soln
        let count+=1
    done < sas_plan

    rm -f output output.sas test.groups sas_plan temporaneo

    echo "Problem solved by downward!"
    exit 0
fi

# file risolto da lpg_q
if grep "solution found" lpg_q &>/dev/null
    then
    
    rm -f $b.soln  &> /dev/null
    touch $b.soln

    val=(`ls --sort time solution*.SOL`)

    count=0
    count_line=0

    for valore in ${val[0]}; do
	if [[ $count -ne 0 ]]; then
	    rm -f $valore
	else
	    while read -r line; do
		a=`echo $line | grep "[0-9][0-9]*:" | cut -d ":" -f2 `
		if [[ ! -z $a ]]; then
		    echo -n "$count_line: " >> $b.soln
		    echo $a >> $b.soln
		    let count_line+=1
		fi
	    done < $valore
	fi	
	let count+=1
    done
    
    echo "Problem solved by lpg_q!"
    exit 0
fi

# file risolto da lpg_t
if grep "solution found" lpg_t &>/dev/null
    then

    rm -f $b.soln  > /dev/null 2>&1
    touch $b.soln

    count=0
    while read -r line; do
	a=`echo $line | grep "[0-9][0-9]*\.[0-9][0-9]*:" | cut -d ":" -f2 |  cut -d "(" -f2 | cut -d ")" -f1 | tr "[a-z]" "[A-Z]"`
        if [[ ! -z $a ]]; then
	    echo "$count: ($a) [1]" >> $b.soln
	    let count+=1
        fi
    done < lpg_t

    echo "Problem solved by lpg_t!"
    exit 0
fi

# file risolto da sgplan
if grep "Solution found" sgplan522 &>/dev/null
    then
    mv -f sgplan $b.soln
     
    echo "Problem solved by sgplan!"
    exit 0
fi


# file risolto da MacroFF
if grep "found legal plan" macroff &>/dev/null
    then

    rm $b.soln  > /dev/null 2>&1
    touch $b.soln

    sed -n -e '/[0-9][0-9]*:/p' macroff > temp_2_2
    count=0
    while read -r line; do
        a=`echo $line | tr  -d "a-z" | cut -d "]" -f2 `
        echo "$count: (${a:1}) [1]" >> $b.soln
	let count+=1
    done < temp_2_2
    
    echo "Problem solved by macroFF!"
    rm temp_2_2 ffua.out
    exit 0
fi


# file risolto da Marvin
if grep "Solution Found" marvin &>/dev/null
    then

    numero_riga=`grep -n ";;;; Solution Found"  marvin | cut -d ":" -f1 2>&1`
    count=0

    rm -f temp &>/dev/null 
    touch temp

    while read -r line; do
	let count=$count+1
	if [[ $count -ge $numero_riga ]]; then
	    echo "$line" | tr "[a-z]" "[A-Z]">> temp
	fi
    done < marvin

    mv -f temp $b.soln

    echo "Problem solved by Marvin!"
    exit 0

fi

# file risolto da YAHSP
if grep "Valid plan" yahsp &>/dev/null
    then

    rm -f $b.soln  &> /dev/null
    rm -f pausa &> /dev/null
    touch pausa

    while read -r line; do
	echo $line | grep "^[0-9]*:" | tr "[a-z]" "[A-Z]" >> pausa
    done < yahsp

    cp -f pausa $b.soln

    echo "Problem solved by YAHSP!"
    exit 0
fi


echo "No solution found!!!" > $b.soln

