#include "best_first_search.h"
#include "cg_heuristic.h"
#include "ff_heuristic.h"
#include "partial_relaxation_heuristic.h"
#include "goal_count_heuristic.h"
#include "globals.h"
#include "operator.h"

#include <iostream>
#include <fstream>
#include <cctype>
#include <string>
#include <vector>
using namespace std;

#include <sys/times.h>

void save_plan(const vector<const Operator *> &plan, char*);

int main(int argc, const char **argv) {
    int nome=0;
    CGHeuristic prova;
    /*struct tms start, search_start, search_end;
    times(&start);
    bool poly_time_method = false;
    
    bool cg_heuristic = false, cg_preferred_operators = false;
    bool ff_heuristic = false, ff_preferred_operators = false;
    bool goal_count_heuristic = false;
    bool partial_relaxation_heuristic = false;
    //for(int i = 1; i < argc; i++) {
      //      cout << i << "\n";
	for(const char *c = argv[1]; *c != 0; c++) {
	    if(*c == 'c') {
		cg_heuristic = true;
	    } else if(*c == 'C') {
		cg_preferred_operators = true;
	    } else if(*c == 'f') {
		ff_heuristic = true;
	    } else if(*c == 'F') {
		ff_preferred_operators = true;
	    } else if(*c == 'p') {
		partial_relaxation_heuristic = true;
	    } else if(*c == 'g') {
		goal_count_heuristic = true;
	    } else {
		//cerr << "Unknown option: " << *c << endl;
		//return 1;
		nome=1;
                break;
	    }
	}
    //}

    char nome_file[1000];
    char *posizione;
    //strcpy(nome_file,argv[2]);
    posizione=strrchr(argv[2],'/');
    if(posizione==NULL)
       strcpy(nome_file,argv[2]);
    else{
        posizione++;
       strcpy(nome_file,posizione);	
       }
    //cout << nome_file <<"\n";	
    strcat(nome_file,".soln");
    if(!cg_heuristic && !ff_heuristic && !partial_relaxation_heuristic
       && !goal_count_heuristic) {
	cerr << "Error: you must select at least one heuristic!" << endl
	     << "If you are unsure, choose options \"cCfF\"." << endl;
	return 2;
    }

    cin >> poly_time_method;
    if(poly_time_method) {
	cout << "Poly-time method not implemented in this branch." << endl;
	cout << "Starting normal solver." << endl;
	// cout << "Aborting." << endl;
	// return 1;
    }
*/
    read_everything(cin);
	prova.initialize();
	cout << prova.compute_heuristic(*g_initial_state);
/*
    // dump_everything();

    BestFirstSearchEngine *engine = new BestFirstSearchEngine;
    if(cg_heuristic || cg_preferred_operators)
	engine->add_heuristic(new CGHeuristic, cg_heuristic,
			      cg_preferred_operators);
    if(ff_heuristic || ff_preferred_operators)
	engine->add_heuristic(new FFHeuristic, ff_heuristic,
			      ff_preferred_operators);
    if(partial_relaxation_heuristic)
	engine->add_heuristic(new PartialRelaxationHeuristic, true, false);
    if(goal_count_heuristic)
	engine->add_heuristic(new GoalCountHeuristic, true, false);

    if(partial_relaxation_heuristic) {
	cout << "The partial relaxation heuristic is unfinished work "
	     << "in progress." << endl
	     << "Please do not use the 'p' option for now." << endl;
	return 2;
    }

    times(&search_start);
    engine->search();
    times(&search_end);
    char aiuto[255];	
    sprintf(aiuto,"D%s",nome_file);
    if(engine->found_solution())
	save_plan(engine->get_plan(),aiuto);

    engine->statistics();
    if(cg_heuristic || cg_preferred_operators) {
	cout << "Cache hits: " << g_cache_hits << endl;
	cout << "Cache misses: " << g_cache_misses << endl;
    }
    int search_ms = (search_end.tms_utime - search_start.tms_utime) * 10;
    cout << "Search time: " << search_ms / 1000.0 << " seconds" << endl;
    int total_ms = (search_end.tms_utime - start.tms_utime) * 10;
    cout << "Total time: " << total_ms / 1000.0 << " seconds" << endl;

    return engine->found_solution() ? 0 : 1;*/
	return 0;
}

void save_plan(const vector<const Operator *> &plan,char *nome) {
    ofstream outfile;
    int h;
    string nome_maiuscolo;
    outfile.open(nome, ios::out);
    for(int i = 0; i < plan.size(); i++) {
        nome_maiuscolo=plan[i]->get_name();
        for (h=0; h<nome_maiuscolo.length(); h++){
             nome_maiuscolo[h]=toupper(nome_maiuscolo[h]);
        }
	cout << plan[i]->get_name() << endl;
	outfile << i <<": (" << nome_maiuscolo << ") [1]" << endl;
    }
    outfile.close();
    cout << "Plan length: " << plan.size() << " step(s)." << endl;
}
