#!/usr/bin/ruby
require 'xmlrpc/client'

instance_relname = ARGV[0]
instance_specifics = ARGV[1]
cutoff_time = ARGV[2].to_f
cutoff_length = ARGV[3].to_i
seed = ARGV[4].to_i

paramConfig = {}
(5..ARGV.length-1).each { |i|
	if (i % 2 != 0) 
		paramConfig[ARGV[i][1..ARGV[i].length-1]] = ARGV[i+1]
	end
}

experimentID = $experimentID$
host = $hostName$
hostPort = $hostPort$
rpcHandler = $rpcHandler$
requestRunCommand = $requestRunCommand$

jsonString = "{
	'experimentID' : #{experimentID},
	'instanceName' : '#{instance_relname}',
	'instanceSeed' : #{seed},
	'runtimeCutoff' : #{cutoff_time},
	'runlengthCutoff' : #{cutoff_length},
	'parameters' : {"

first = true;
paramConfig.each { |key, value|
	if (!first) 
		jsonString = "#{jsonString},"
	else
		first = false
	end

	jsonString = "#{jsonString}
		#{key} : '#{value}'"
}

jsonString = "#{jsonString}
	} 
}"

server = XMLRPC::Client.new(host, "/xmlrpc", hostPort, nil, nil, nil, nil, nil, 99999)

begin
	$stderr.puts "Making Configurator run request #{cutoff_time} #{cutoff_length} #{seed}"
	result = server.call("#{rpcHandler}#{requestRunCommand}", jsonString) 

	#$stderr.puts "Run request finished!!!"
	$stderr.puts result
	puts result
rescue XMLRPC::FaultException => e
	$stderr.puts "Error: "
	$stderr.puts e.faultCode
	$stderr.puts e.faultString
end
